#ifndef _ENCODER_H
#define _ENCODER_H

#define FORCE_PERM_CHECK

/// load the permutation 
///\param *perm is the permutation array
///\param K is the permutation length
///\param code is a boolean: 0->UMTS, 1->LTE
void get_perm(int *perm, int K, int code); 
/// CC1 encoder
///\param nstep is the number of trellis steps including the termination
///\param *input is the uncoded bit array
///\param *output is the coded bit array
void Encoder12_8(const int nstep, const int* input, int* output);
/// CC2 encoder
///\param nstep is the number of trellis steps including the termination
///\param *input is the uncoded bit array
///\param *output is the coded bit array
void Encoder11_8(const int nstep, const int* input, int* output);

#endif
