#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"random.h"


int lfsr(unsigned int *l)
{
  int b,l2;

  b = ( (*l & (1 << 31) ) >> 31 ) ; 

  l2 =   (*l & 1) ^ ( (*l & (1 << 1)) >> 1 ) ^ ( (*l & (1 << 21)) >> 21 ) ^ b ;

  *l = (*l << 1) | l2;

  return(b);
}

double unif(unsigned int *vc_un)
{
  long s;
  long m=0x7FFFFFFF,a=16807,q=127773,r=2836;
  unsigned int tmp;

  tmp = *vc_un;

  s=tmp/q;
  tmp=a*(tmp-q*s)-r*s;
  if (tmp<=0) tmp+=m;

  *vc_un = tmp;

  return ( (double) (*vc_un)/m );
}

double Gaussian(unsigned int *seed)
{
  static double f1,f2,f3,a;
  static double x2;
  static int isready=0;
  if(isready)
  {
    isready=0;
    return x2;
  }
  else
  {

    f3 = 100.0;
    while (f3 > 1.0)
    {
      f1 = 2.0 * unif(seed) - 1.0 ;
      f2 = 2.0 * unif(seed) - 1.0 ;
      f3 = f1*f1 + f2*f2;
    }
    a = sqrt(-2.0 * log(f3)/f3);  

    x2 = f2 * a;
    isready=1;
    return (f1 * a);
  }
}
