#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"myretcodes.h"
#include"myservs.h"
#include "params_define.h"
#include"decoder.h"
#include"main2_stimuli.h"
#include "bench.h"

int dec1[K]; /// SISO1 decision
int llr1_out[K]; /// SISO1 extrinsic information
int llr2_out[K]; /// SISO1 extrinsic information
siso_mem_t siso_memory[2][P]; /// siso memory structure array
int beta_init[2][NS];
int bit_dec;
int main()
{

	
  int INT_MAX_VAL; /// intrinsic information maximum value
  int INT_MIN_VAL; /// intrinsic information minimum value


  int *ic = NULL; /// log-MAP correction table pointer
  int ic_size; /// log-MAP correction table size

  int *term[2]; /// pointer to CC terminations

  int i,j,k; 

  int curr_iter; /// current iteration
  unsigned int tot_iter; /// total number of iterations for statistic purpose

  int SM_INIT; /// state metric initialization value
  SM_INIT = -(1 << (NB_SM-1));

  ic_size = compute_table(&ic, NBF_INT); 

	for(i=0;i <K; i++)
	{
		llr1_out[i] = 0;
  	llr2_out[i] = 0;
	}
	
  tot_iter = 0;
      /// initialize SISO memories
    for (i=0; i<P; i++)
    {

			for (k=0; k<NS; k++)
			{
					
					siso_memory[0][i].alpha_mem[0][k] = 0;
					siso_memory[1][i].alpha_mem[0][k] = 0;
					siso_memory[0][i].beta[0][k] = 0;
					siso_memory[0][i].beta[1][k] = 0;
					siso_memory[1][i].beta[0][k] = 0;
					siso_memory[1][i].beta[1][k] = 0;
					siso_memory[0][i].alpha_ext_mem[k] = 0;
					siso_memory[1][i].alpha_ext_mem[k] = 0;
					siso_memory[0][i].beta_ext_mem[k] = 0;
	  			siso_memory[1][i].beta_ext_mem[k] = 0;

			}
			for (j=0; j<NWP; j++)
			{

				for (k=0; k<NS; k++)
				{

					siso_memory[0][i].beta_local_mem[j][k] = 0;
					siso_memory[1][i].beta_local_mem[j][k] = 0;
				}
			}	  	
     }            

      /// set termination pointers
     term[0] = llr_in+2*K;
     term[1] = llr_in+2*(K+3)+K;

      /// initialize the last trellis section portion
     for (i=0; i<2; i++)
     {
				beta_init[i][0] = 0; 
				beta_init[i][1] = term[i][0] + term[i][1]; 
				beta_init[i][2] = term[i][0] + term[i][2] + term[i][3]; 
				beta_init[i][3] = term[i][1] + term[i][2] + term[i][3]; 
				beta_init[i][4] = term[i][1] + term[i][2] + term[i][4] + term[i][5];  
				beta_init[i][5] = term[i][0] + term[i][2] + term[i][4] + term[i][5];  
				beta_init[i][6] = term[i][0] + term[i][1] + term[i][3] + term[i][4] + term[i][5];  
				beta_init[i][7] = term[i][3] + term[i][4] + term[i][5];  
     }

		cpu_perf_conf_events(SPR_PCER_EVENT_MASK(0));	
		perf_reset();
      /// iteration loop      
     for (curr_iter=min_iter; curr_iter<max_iter; curr_iter++)
     {	

				SISO1(1, llr2_out, llr_in+2*(K+3), SM_INIT, siso_memory[1], dec1, ic, ic_size, beta_init[1]); 

				descrambler(perm, llr2_out, llr1_out); 
				SISO1(0, llr1_out, llr_in, SM_INIT, siso_memory[0], dec1, ic, ic_size, beta_init[0]); 
				
				scrambler(perm, llr1_out, llr2_out); 
				tot_iter++;

     }
     for(i=0;i<K;i++)
     {
     		if(dec1[i]>=0)
     			bit_dec =1;
     		else
     			bit_dec=0;
     	}
   		perf_stop();
 		  printf("cpu cycles=%d\n",cpu_perf_get(0));
     	return 0;
}



