#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"myretcodes.h"
#include"myservs.h"
#include"rt/rt_api.h"
#include "execution.h"
#include "decoder.h"

int main ()
{
	
	int i,j;
  rt_cluster_mount(1, 0, 0, NULL);

	struct allocation *fc_side;
	fc_side = (struct allocation *) rt_alloc(RT_ALLOC_L2_CL_DATA, sizeof(struct allocation));
 	fc_side->K=1536;
 	fc_side->P=6;//non può essere più di 7 perché un core deve essere sempre impiegato per fornire i frame. Dato che i core sono massimo 8 P deve essere sempre <=7
 	fc_side->W=64;
 	fc_side->min_iter=1;
 	fc_side->max_iter=8;
 	fc_side->max_frame=1;
 	fc_side->NBF_INT=1;
 	fc_side->EXT_MAX_VAL=127;
 	fc_side->EXT_MIN_VAL=-128;
 	fc_side->NB_SM=12;
 	fc_side->f_num=1;
 	fc_side->NS=8;
 	fc_side->NWP=fc_side->K/(fc_side->W*fc_side->P);
 	fc_side->N=(fc_side->K*3)+12;
  fc_side->llr_in[0] = (int *) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->N*sizeof(int));
  fc_side->llr_in[1] = (int *) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->N*sizeof(int));
	fc_side->llr1_out = (int *) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->K*sizeof(int));
  fc_side->llr2_out = (int *) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->K*sizeof(int));
  fc_side->dec1 = (int *) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->K*sizeof(int));  
	fc_side->siso_memory[0] = (siso_mem_t*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->P*sizeof(siso_mem_t)); 
  fc_side->siso_memory[1] = (siso_mem_t*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->P*sizeof(siso_mem_t)); 
  for (i=0; i<fc_side->P; i++)
  {
    fc_side->siso_memory[0][i].alpha_mem = (int**) rt_alloc(RT_ALLOC_L2_CL_DATA, (fc_side->W+1)*sizeof(int*));
    fc_side->siso_memory[1][i].alpha_mem = (int**) rt_alloc(RT_ALLOC_L2_CL_DATA, (fc_side->W+1)*sizeof(int*)); 
    for (j=0; j<=fc_side->W; j++)
    {
      fc_side->siso_memory[0][i].alpha_mem[j] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
      fc_side->siso_memory[1][i].alpha_mem[j] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    }
    fc_side->siso_memory[0][i].beta_local_mem = (int**) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NWP*sizeof(int*));
    fc_side->siso_memory[1][i].beta_local_mem = (int**) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NWP*sizeof(int*));
    for (j=0; j<fc_side->NWP; j++)
    {
      fc_side->siso_memory[0][i].beta_local_mem[j] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
      fc_side->siso_memory[1][i].beta_local_mem[j] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    }
    fc_side->siso_memory[0][i].beta[0] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    fc_side->siso_memory[0][i].beta[1] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    fc_side->siso_memory[1][i].beta[0] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    fc_side->siso_memory[1][i].beta[1] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    fc_side->siso_memory[0][i].alpha_ext_mem = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    fc_side->siso_memory[1][i].alpha_ext_mem = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    fc_side->siso_memory[0][i].beta_ext_mem = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
    fc_side->siso_memory[1][i].beta_ext_mem = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
  }
  fc_side->beta_init[0] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
  fc_side->beta_init[1] = (int*) rt_alloc(RT_ALLOC_L2_CL_DATA, fc_side->NS*sizeof(int));
  
  // This is the most basic call we can do to the cluster with all default
  // parameters (default stack size, max number of cores, etc) and is 
  // synchronous (last event parameter is NULL) which means we are blocked
  // until the call is finished
  rt_cluster_call(NULL, 0, execution,(void *) fc_side, NULL, 0, 0, fc_side->P+1, NULL);

  // It must then be unmounted when it is not needed anymore so that it is turned off
  rt_cluster_mount(0, 0, 0, NULL);

  return OK_RET;
}
