#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"myretcodes.h"
#include"myservs.h"
//#include "params_define.h"
#include"decoder.h"
#include"main2_stimuli.h"
#include"rt/rt_api.h"
#include "execution.h"

RT_L2_DATA signed char *llr_in[2];
RT_L2_DATA short *dec1; /// SISO1 decision
RT_L2_DATA signed char *llr1_out; /// SISO1 extrinsic information
RT_L2_DATA signed char *llr2_out; /// SISO1 extrinsic information
RT_L2_DATA siso_mem_t *siso_memory[2]; /// siso memory structure array
RT_L2_DATA short *beta_init[2];
RT_L2_DATA signed char bit_dec;
RT_L1_DATA volatile int tas1=-1;
RT_L1_DATA volatile int tas2=-1;
RT_L1_DATA volatile int tas3;
RT_L1_DATA volatile int tas4;
RT_L2_DATA volatile int flag=1;
RT_L2_DATA int *a;
RT_L2_DATA rt_perf_t perf;
RT_L2_DATA struct allocation *cluster_side;
int *ic = NULL; /// log-MAP correction table pointer
int ic_size; /// log-MAP correction table size
signed char *term[2]; /// pointer to CC terminations

short SM_INIT; /// state metric initialization value
void parallelization1()
{

if(rt_core_id()==0)
{
	rt_perf_init(&perf);
	rt_perf_conf(&perf, (1<<RT_PERF_CYCLES));
}
signed char curr_frame; /// current frame index
short i,j,k; 
signed char curr_iter; /// current iteration
for (curr_frame=cluster_side->f_num; curr_frame<=cluster_side->max_frame; curr_frame++)
  {
  if(rt_core_id()==cluster_side->P)
  {
		if(((curr_frame-1)%2)==0){
  		while (rt_tas_lock_32((unsigned int)&tas3) == -1);
  		for(i=0;i<cluster_side->N;i++){
				llr_in[(curr_frame-1)%2][i]=llr_in_L2[i];
				}
			rt_tas_unlock_32((unsigned int)&tas1,0);
		}
		if(((curr_frame-1)%2)==1){
  		while (rt_tas_lock_32((unsigned int)&tas4) == -1);
		for(i=0;i<cluster_side->N;i++)
			llr_in[(curr_frame-1)%2][i]=llr_in_L2[i];
		rt_tas_unlock_32((unsigned int)&tas2,0);
		}
		
		
  }
 
  if(rt_core_id()==0)
	{
	for(i=0;i<cluster_side->K; i++)
	{
		llr1_out[i] = 0;
  	llr2_out[i] = 0;
	}
	
      /// initialize SISO memories
    for (i=0; i<cluster_side->P; i++)
    {
	
			for (k=0; k<cluster_side->NS; k++)
			{
	
					siso_memory[0][i].alpha_mem[0][k] = 0;
					siso_memory[1][i].alpha_mem[0][k] = 0;
					siso_memory[0][i].beta[0][k] = 0;
					siso_memory[0][i].beta[1][k] = 0;
					siso_memory[1][i].beta[0][k] = 0;
					siso_memory[1][i].beta[1][k] = 0;
					siso_memory[0][i].alpha_ext_mem[k] = 0;
					siso_memory[1][i].alpha_ext_mem[k] = 0;
					siso_memory[0][i].beta_ext_mem[k] = 0;
	  			siso_memory[1][i].beta_ext_mem[k] = 0;

			}
			for (j=0; j<cluster_side->NWP; j++)
			{
				for (k=0; k<cluster_side->NS; k++)
				{

					siso_memory[0][i].beta_local_mem[j][k] = 0;
					siso_memory[1][i].beta_local_mem[j][k] = 0;

				}
			}	  	
     }          
     if(((curr_frame-1)%2)==0){
			while (rt_tas_lock_32((unsigned int)&tas1) == -1);
		}
		if(((curr_frame-1)%2)==1){
			while (rt_tas_lock_32((unsigned int)&tas2) == -1);
		}  

      /// set termination pointers
     term[0] = llr_in[(curr_frame-1)%2]+2*cluster_side->K;
     term[1] = llr_in[(curr_frame-1)%2]+2*(cluster_side->K+3)+cluster_side->K;
			
      /// initialize the last trellis section portion
     for (i=0; i<2; i++)
     {
				beta_init[i][0] = 0; 
				beta_init[i][1] = term[i][0] + term[i][1]; 
				beta_init[i][2] = term[i][0] + term[i][2] + term[i][3]; 
				beta_init[i][3] = term[i][1] + term[i][2] + term[i][3]; 
				beta_init[i][4] = term[i][1] + term[i][2] + term[i][4] + term[i][5];  
				beta_init[i][5] = term[i][0] + term[i][2] + term[i][4] + term[i][5];  
				beta_init[i][6] = term[i][0] + term[i][1] + term[i][3] + term[i][4] + term[i][5];  
				beta_init[i][7] = term[i][3] + term[i][4] + term[i][5];  
     }
    
  	
  	rt_perf_reset(&perf);
  	rt_perf_start(&perf);
}

			if(rt_core_id()<cluster_side->P){
      /// iteration loop      
     for (curr_iter=cluster_side->min_iter; curr_iter<cluster_side->max_iter; curr_iter++)
     {	
				
				SISO1(1, cluster_side->NS, llr2_out, llr_in[(curr_frame-1)%2]+2*(cluster_side->K+3), SM_INIT, cluster_side->P, cluster_side->W, cluster_side->NWP, cluster_side->EXT_MAX_VAL, cluster_side->EXT_MIN_VAL, siso_memory[1], dec1, ic, ic_size, beta_init[1]); 

			if(rt_core_id()==0)
			{
				
				descrambler(perm, llr2_out, llr1_out, cluster_side->K); 
			}

				SISO1(0, cluster_side->NS, llr1_out, llr_in[(curr_frame-1)%2], SM_INIT, cluster_side->P, cluster_side->W, cluster_side->NWP, cluster_side->EXT_MAX_VAL, cluster_side->EXT_MIN_VAL, siso_memory[0], dec1, ic, ic_size, beta_init[0]); 

			if(rt_core_id()==0)
			{
		
				scrambler(perm, llr1_out, llr2_out, cluster_side->K); 
			}

     }
			rt_team_barrier();
     if(rt_core_id()==0)
		 {
	   	for (i=0; i<cluster_side->K; i++)
	 		{
	  	  if (dec1[i] >= 0)
	    	  bit_dec = 1;
	    	else
	    	  bit_dec = 0;
			}
			
			
				rt_perf_stop(&perf);
		  	printf("Core=%d Number of total cycles:%d\n",rt_core_id(), rt_perf_read(RT_PERF_CYCLES));

			if(((curr_frame-1)%2)==0)
				rt_tas_unlock_32((unsigned int)&tas3,0);
			if(((curr_frame-1)%2)==1)
				rt_tas_unlock_32((unsigned int)&tas4,0);
			}
			}

}

	if(rt_core_id()==cluster_side->P)
	{
		while(1);
	}
		

rt_team_barrier();
}

void execution (void *c)
{
	cluster_side = (struct allocation *) c;
	llr_in[0]=cluster_side->llr_in[0];
	llr_in[1]=cluster_side->llr_in[1];
	llr1_out=cluster_side->llr1_out;
	llr2_out=cluster_side->llr2_out;
	dec1=cluster_side->dec1;
	siso_memory[0]=cluster_side->siso_memory[0];
	siso_memory[1]=cluster_side->siso_memory[1];
	beta_init[0]=cluster_side->beta_init[0];
	beta_init[1]=cluster_side->beta_init[1];
	
  SM_INIT = -(1 << (cluster_side->NB_SM-1));

  ic_size = compute_table(&ic, cluster_side->NBF_INT); 
  
  unsigned int core_mask1 = (1<<(cluster_side->P+1)) - 1;
	unsigned int core_mask2 = (1<<(cluster_side->P)) - 1;
  eu_dispatch_team_config(core_mask1);
  __rt_team_barrier_config(core_mask2);
	eu_dispatch_push((int)parallelization1);
  eu_dispatch_push((int)NULL);
  parallelization1(NULL);

  rt_team_barrier();
}



